SystemOrganization addCategory: #'StashShell-MC'!

StashNIXdev subclass: #StashMCConfigs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCConfigs classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:52'!
isMountable

	^true! !

!StashMCConfigs classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:11'!
mountName
	^'configs'! !

!StashMCConfigs methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:32'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	((MetacelloToolBox configurationClasses
		collect: [ :each | 
			| configName |
			configName := each name asString.
			(configName beginsWith: 'ConfigurationOf')
				ifTrue: [ configName copyFrom: 'ConfigurationOf' size + 1 to: configName size ]
				ifFalse: [ configName ] ]) asArray sort: [ :a :b | a <= b ])
		do: [ :configName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: configName.
			first := false ].
	^ stream contents! !

!StashMCConfigs methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:28'!
lookupChildNamed: aString ifAbsent: absentBlock
	(StashShellNoSuchChild signal: aString)
		ifTrue: [ absentBlock value ]! !

!StashMCConfigs methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 16:02'!
name
	name ifNil: [^self class mountName ].
	^name! !

StashNIXdev subclass: #StashMCPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCPackages classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:52'!
isMountable

	^true! !

!StashMCPackages classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:11'!
mountName
	^'pkgs'! !

!StashMCPackages methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:16'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	((MCWorkingCopy allManagers collect: [ :each | each packageName ]) asArray sort: [ :a :b | a <= b ])
		do: [ :packageName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: packageName.
			first := false ].
	^ stream contents! !

!StashMCPackages methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:28'!
lookupChildNamed: aString ifAbsent: absentBlock
	(StashShellNoSuchChild signal: aString)
		ifTrue: [ absentBlock value ]! !

!StashMCPackages methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 16:02'!
name
	name ifNil: [^self class mountName ].
	^name! !

StashNIXdev subclass: #StashMCRepositories
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCRepositories classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:53'!
isMountable

	^true! !

!StashMCRepositories classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:11'!
mountName
	^'repos'! !

!StashMCRepositories methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:17'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	((MCRepositoryGroup default repositories collect: [ :each | each description ]) asArray sort: [ :a :b | a <= b ])
		do: [ :packageName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: packageName.
			first := false ].
	^ stream contents! !

!StashMCRepositories methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:28'!
lookupChildNamed: aString ifAbsent: absentBlock
	(StashShellNoSuchChild signal: aString)
		ifTrue: [ absentBlock value ]! !

!StashMCRepositories methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 16:02'!
name
	name ifNil: [^self class mountName ].
	^name! !

StashNIXBuiltInCommand subclass: #StashMCmcCommand
	instanceVariableNames: 'cmd commandArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCmcCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 19:51'!
commandString

	^'mc'! !

!StashMCmcCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:18'!
cmd

	^cmd! !

!StashMCmcCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:19'!
commandArgs

	^commandArgs! !

!StashMCmcCommand methodsFor: 'private' stamp: 'DaleHenrichs 12/16/2010 21:25'!
ensureMetacello
	(Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ].
			Smalltalk at: #MetacelloBaseConfiguration ]) ensureMetacello! !

!StashMCmcCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/16/2010 21:19'!
executeAgainst: aStashShellDevice in: aStashShell
	self helpFlag ifTrue: [ ^self usageMessage ].
	cmd = 'install'
		ifTrue: [ ^self installAgainst:  aStashShellDevice in: aStashShell ].
	^ ''! !

!StashMCmcCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/16/2010 21:32'!
installAgainst: aStashShellDevice in: aStashShell
	| configName version groups repoPath |
	repoPath := self commandArgs at: 1.
	configName := self commandArgs at: 2.
	self commandArgs size > 2
		ifTrue: [ version := self commandArgs at: 3 ]
		ifFalse: [ version := #stable ].
	self commandArgs size > 3
		ifTrue: [ groups := self commandArgs copyFrom: 4 to: self commandArgs size - 3 ]
		ifFalse: [ groups := #() ].
	self halt.
	self ensureMetacello.
	(((Smalltalk at: MetacelloToolBox) configurationNamed: configName) project version: version) load: groups.
	^ ''! !

!StashMCmcCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/16/2010 19:51'!
processArgs: argsString
	| args |
	args := self parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self missingOperandError ].
	commandArgs := OrderedCollection new.
	self getopts: args into: commandArgs.
	commandArgs size >= 1
		ifTrue: [ cmd := commandArgs removeFirst ].
! !

!StashMCmcCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 19:54'!
usage

	^'mc <subcommand> [options] [args]'! !

!StashMCmcCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:42'!
usageMessage
	"mc <subcommand> [options] [args]"

	^self usage, '
	Metacello command-line client.

	Examples:
	
	mc help <subcommand>

	mc mount <repository uri> <repoPath> 
	mc install <repoPath> <config name> [version] [group names]
	mc download <repoPath> <config name> [version] [group names] "perhaps stashing pkgs somewhere?"
	mc update <repoPath> <config name>
	mc commit <config name> <commit message>
	mc show "lists installed configs"
' ! !

StashNIXetc subclass: #StashMCRepos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCRepos classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/16/2010 21:09'!
isMountable

	^true! !

!StashMCRepos classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:43'!
mountName
	^'mc'! !

!StashMCRepos methodsFor: 'builtins' stamp: 'DaleHenrichs 12/16/2010 21:13'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	#('blueplane' 'croquet' 'defaut' 'gemsource' 'impara' 'renggli' 'saltypickle' 'squeakfoundation' 'squeaksource' 'wiresong' )
		do: [ :packageName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: packageName.
			first := false ].
	^ stream contents! !

!StashMCRepos methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:09'!
name
	name ifNil: [^self class mountName ].
	^name! !

!StashMCRepos methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:15'!
repoLocations

	^#('http://squeaksource.blueplane.jp/' 'http://hedgehog.software.umn.edu:8888/' 'http://seaside.gemstone.com/ss/' 'http://source.impara.de/' 'http://source.lukas-renggli.ch/' 'http://squeak.saltypickle.com/' 'http://source.squeakfoundation.org/' 'http://www.squeaksource.com/' 'http://source.wiresong.ca/' )! !

!StashMCRepos methodsFor: 'accessing' stamp: 'DaleHenrichs 12/16/2010 21:13'!
repoNames

	^#('blueplane' 'croquet' 'defaut' 'gemsource' 'impara' 'renggli' 'saltypickle' 'squeakfoundation' 'squeaksource' 'wiresong' )! !
